unit CrtSim51Utils;

interface

function  HexDec(x:Char):Byte;
procedure LoadFileHex(Fname: string);

implementation
uses CrtSim51HW;

const Digits  : array[0..$F]    of Char = '0123456789ABCDEF';

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function HexDec(x:Char):Byte;
var i:Byte;
begin
  for i:=0 to 15 do if x=Digits[i] then Break;
  HexDec:=i;
end;

//------------------------------------------------------------------------------
//  Nacte souboru ve formtu IntelHEX
//------------------------------------------------------------------------------
procedure LoadFileHex(Fname: string);
var    FIn   : Text;
       Data  : string;
       Count : Byte;
       Adr   : Word;
       i     : Byte;
begin
  if Length(FName)>0 then begin
    Assign(FIn,Fname);
    Reset(FIn);
    repeat
      ReadLn(FIn,Data);
      if (Data[1]=':')and(Data[9]='0') then begin
        Count:=HexDec(Data[2])*16+HexDec(Data[3]);
        Adr  :=HexDec(Data[4])*$1000+HexDec(Data[5])*$100+HexDec(Data[6])*$10+HexDec(Data[7]);
        for i:=0 to count-1 do begin
          WorkBuf^[Adr]:=HexDec(Data[10+i*2])*16+HexDec(Data[11+i*2]);
          Inc(Adr);
        end;
      end
      else Break;
    until True=False;
  end;
end;

//------------------------------------------------------------------------------
end.
