program CrtSim51;

uses CrtSim51HW    in 'CrtSim51HW.pas',
     CrtSim51Utils in 'CrtSim51Utils.pas',
     Windows;

var  FileName,
     RunExe  : string;
     Port    ,
     Error   : integer;
//     Size    : word;
begin
  RunExe    := ParamStr(0);
  FileName  := ParamStr(1);
  Val(ParamStr(2), Port, Error);
  if Error=0 then
    case Port of
      1: Port:= $378;
      2: Port:= $278;
      3: Port:= $3BC;
      4: Port:= $1020;
    else Error:=1;
    end;
  if (Error=0) and (FileName<>'') then begin
    New(WorkBuf);
    FillChar(WorkBuf^,SizeOf(WorkBuf^),$FF);
    Size:= $FFFF;
    EppOpen(Port);
    LoadFileHex(FileName);
    SimWrite;
    SimWrite;
    if not SimVerify then MessageBox(0, 'Chyba zapisu do SRAM', 'Error', MB_OK);
    EppClose;
    Dispose(WorkBuf);
  end
  else MessageBox(0, 'Syntax: EppCrtSim FILE.HEX P'+#10+#13+
                     '   P = 1 -> LPTBase = $0378'+#10+#13+
                     '   P = 2 -> LPTBase = $0278'+#10+#13+
                     '   P = 3 -> LPTBase = $03BC'+#10+#13+
                     '   P = 4 -> LPTBase = $1020'+#10+#13
                     , 'Chybne parametry', MB_OK);
end.
